Chuyển đến nội dung
Diễn đàn CADViet
Đăng nhập để thực hiện theo  
manhti14

[Nhờ Tạo Lisp] Lisp Ẩn, Đổi Màu Nhiều Layer

Các bài được khuyến nghị

Công ty e làm hay có bản vẽ tự động, khi làm việc thì chỉ cần hiện ra một số layer và e muốn đổi màu 1 số layer để cho dễ nhìn.

Em nhờ mọi người viết hộ e cái lisp để đổi màu với ẩn nhiều layer bằng 1 command "chinhlayer", em xin cảm ơn

 

Nội dung cụ thể:

 

Ẩn các layer:   141,   161,   174,   202,   211,  269,   271,   278,   284

Đổi màu các layer:        14 sang màu 5, 160 sang màu 4, 163 sang màu 6, 178 sang màu 6, 185 sang màu 1, 197 sang màu 6, 21 sang màu 40, 22 sang màu 40, 23 sang màu 40

 

 

Tuy nhiên đôi khi có một số layer ko có trong bản vẽ.

 

Em xin cảm ơn.

 

 

  • Vote giảm 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Ô tranh thủ quick code cho bạn cho đỡ quên. Chưa test nha ^^

(defun c:chinhlayer(/ cl l c n a)
	(vl-load-com)  
	(setq	cl '((14 . 5)(160 . 4)(163 . 6)(178 . 6)(185 . 1)(197 . 6)(21 . 40)(22 . 40)(23 . 40))
			l '("141" "161" "174" "202" "211" "269" "271" "278" "284")
			c (getvar 'clayer)
	)	
	(vlax-map-collection
		(vla-get-Layers	(vla-get-ActiveDocument(vlax-get-acad-object)))
		'(lambda(x)
			(if (and (member (setq n (vla-get-name x)) l)(not (eq n c)))(vla-put-LayerOn x :vlax-false))
			(if (setq a	(assoc (vla-get-color x) cl))(vla-put-color x (cdr a)))
		)
	)
	(princ)
)
  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

K đổi thì hơi lạ nhỉ. Ừ. Hay ý bạn là layer có tên "14" thì chuyênr thành màu 5 ? Mình đang viết layer có màu 14 chuyển thành màu 5. Vui lòng confirm để mình chỉnh ngay

  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Thế thì còn ngắn hơn :)

(defun c:1(/ cl l c n a)
	(vl-load-com)  
	(setq	cl '(("14" . 5)("160" . 4)("163" . 6)("178" . 6)("185" . 1)("197" . 6)("21" . 40)("22" . 40)("23" . 40))
			l '("141" "161" "174" "202" "211" "269" "271" "278" "284")
			c (getvar 'clayer)
	)	
	(vlax-map-collection
		(vla-get-Layers	(vla-get-ActiveDocument(vlax-get-acad-object)))
		'(lambda(x)
			(if (and (member (setq n (vla-get-name x)) l)(not (eq n c)))(vla-put-LayerOn x :vlax-false))
			(if (setq a	(assoc n cl))(vla-put-color x (cdr a)))
		)
	)
	(princ)
)
  • Vote tăng 1

Chia sẻ bài đăng này


Liên kết tới bài đăng
Chia sẻ trên các trang web khác

Tạo một tài khoản hoặc đăng nhập để nhận xét

Bạn cần phải là một thành viên để lại một bình luận

Tạo tài khoản

Đăng ký một tài khoản mới trong cộng đồng của chúng tôi. Điều đó dễ mà.

Đăng ký tài khoản mới

Đăng nhập

Bạn có sẵn sàng để tạo một tài khoản ? Đăng nhập tại đây.

Đăng nhập ngay

Đăng nhập để thực hiện theo  

×